import es, os.path, os, time, errorlib

# Addon info
info			= es.AddonInfo()
info.name		= "Command Logger"
info.version	= "0.1"
info.url		= "http://addons.eventscripts.com/addons/view/cmd_logger"
info.author		= "Ojii"
info.basename	= "cmd_logger"

# Some globals:
scl_commandList = []
cl_commandList = []
logdir = es.ServerVar('eventscripts_gamedir') + '/cmdlogs/'
commandFile = es.ServerVar('eventscripts_gamedir') + '/cfg/cmd_logger_cmd.cfg'
sayCommandFile = es.ServerVar('eventscripts_gamedir') + '/cfg/cmd_logger_saycmd.cfg'

# Registers stuff
def load():
	global logfile, currentday
	errorlib.registerAddon(info,'me@ojii.ch')
	new = False
	if not os.path.exists(logdir):
		os.mkdir(logdir)
		new = True
	logfile = open(logdir + time.strftime('%Y%m%d') + '_cmdlog.log','a')
	currentday = time.strftime('%Y%m%d')
	if new:
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % ('SteamID','Username','Command','Time'))
		logfile.write('------------------------------------------------------------------------------------------------------------------------\n')
	es.addons.registerSayFilter(saycmd_filter)
	es.addons.registerClientCommandFilter(clientcmd_filter)
	readCommandFile()
	readSayCommandFile()

# Changes the logfile if a new day started, rereads configs
def es_map_start(e):
	global logfile,currentday
	if currentday != time.strftime('%Y%m%d'):
		logfile.close()
		logfile = open(logdir + time.strftime('%Y%m%d') + '_saycmdlog.log','a')
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % ('SteamID','Username','Command','Time'))
		logfile.write('------------------------------------------------------------------------------------------------------------------------\n')
	readCommandFile()
	readSayCommandFile()

# unregister the stuff
def unload():
	errorlib.unregisterAddon(info)
	es.addons.unregisterSayFilter(saycmd_filter)
	es.addons.unregisterClientCommandFilter(clientcmd_filter)
	logfile.close()

# Filters anything said for commands in the cfg
def saycmd_filter(userid, message, teamonly):
	global scl_commandList
	text = message.strip('"')
	if text in scl_commandList:
		es.dbgmsg(1,'[SAYCMD-LOGGER] Player used command in list!')
		steamid = es.getplayersteamid(userid)
		username = es.getplayername(userid)
		command = text
		thetime = time.strftime("%a, %d %b %Y %H:%M:%S")
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % (steamid,username,command,thetime))
	return (userid, text, teamonly)

# Filters client commands for commands in the cfg
def clientcmd_filter(userid,args):
	text = args[0]
	if text in scl_commandList:
		es.dbgmsg(1,'[SAYCMD-LOGGER] Player used command in list!')
		steamid = es.getplayersteamid(userid)
		username = es.getplayername(userid)
		command = text
		thetime = time.strftime("%a, %d %b %Y %H:%M:%S")
		logfile.write('%-20s | %-50s | %-15s | %-25s\n' % (steamid,username,command,thetime))
	return True

# Reads the say command configs
def readSayCommandFile():
	global scl_commandList
	scl_commandList = []
	if os.path.exists(sayCommandFile):
		f = open(sayCommandFile,'r')
		for line in f.read().splitlines():
			scl_commandList.append(line)
			es.dbgmsg(1,'[SAYCMD-LOGGER] Adding command: %s' % line)
		f.close()
	else:
		es.dbgmsg(0,'[SAYCMD-LOGGER] cmd_logger_saycmd.cfg not found!')

# reads the client command configs
def readCommandFile():
	global cl_commandList
	cl_commandList = []
	if os.path.exists(commandFile):
		f = open(commandFile,'r')
		for line in f.read().splitlines():
			cl_commandList.append(line)
			es.dbgmsg(1,'[SAYCMD-LOGGER] Adding command: %s' % line)
		f.close()
	else:
		es.dbgmsg(0,'[SAYCMD-LOGGER] cmd_logger_cmd.cfg not found!')